/*

    SayHighLighted(fromRow, toRow)	legge tutto quello che e` evidenziato
					tra la riga fromRow fino a toRow

    SayCursor()				legge dal cursore, fino a fine riga
*/

#include <fcntl.h>


#include "args.h"
#include "../festival.h"



extern int cons;

char *makeAcc2(char *);
int makeArgs(char *, int);
char *pari(char *);
char *dispari(char *);
int isHighL(char *);
char *selectH(char *);

//char *makeAcc(char *); 

	




int SayHighlighted(char *args) {

    int fd, i=0, fromRow=0, toRow=0;
    char *conname = (char *) malloc(20), *line = (char *) malloc(161), attrib;
    char *toRead = (char *) malloc(256);

    sprintf(conname, "/dev/vcsa%d", cons);
    if ( (fd = open(conname, O_RDONLY, 0)) < 0 ) { perror("Can't open /dev/vcs"); return -1;}
    
    fromRow = makeArgs(args, 1);	toRow = makeArgs(args, 2);
    lseek(fd, 4+(2*(fromRow-1)*80), SEEK_SET);    
    for(i=fromRow; i<=toRow; i++) {
	read(fd, line, 160);
//    	printf("%s", makeAcc2(selectH(line)));	
	sprintf(toRead, "%s", makeAcc2(selectH(line)));
	if (strcmp(toRead, "") != 0) {
	    if (festivalSpeech(info, toRead) != 0) printf("Errore nella Speech!\n");
	    printf("SayHighlighted: %s \n", toRead);		
	}
	bzero(toRead, 256);
    }

    free(conname);	free(line);
    close(fd);

return 0;
}



int SayCursor() {	// legge dal cursore, fino a fine linea

    int fd, i=0, x=0, y=0;
    char *conname = (char *) malloc(20), *line = (char *) malloc(161), attrib;
    char *toRead = (char *) malloc(256);

    sprintf(conname, "/dev/vcsa%d", cons);
    if ( (fd = open(conname, O_RDONLY, 0)) < 0 ) { perror("Can't open /dev/vcs"); return -1;}
    
    lseek(fd, 2, SEEK_SET);    
    read(fd, &x, 1);	read(fd, &y, 1);
    

    lseek(fd, (2*(y*80+x)), SEEK_CUR );    
    read(fd, line, (160-(2*x)) );

    sprintf(toRead, "%s", makeAcc2(pari(line)));
    if (strcmp(toRead, "") != 0) {
        if (festivalSpeech(info, toRead) != 0) printf("Errore nella Speech!\n");
	printf("SayCursor: %s \n", toRead);		
    }
    bzero(toRead, 256);
//    printf("%s\n\n", makeAcc2(pari(line)));	

    free(conname);	free(line);
    close(fd);

return 0;
}


/*
int main() {
    int from = 3, to = 23;

    printf("SayCursor() = %d\n\n", SayCursor());
    printf("SayHighlighted(%d, %d) = %d\n\n", from, to, SayHighlighted(from, to));
//    printf("SayFirstHalfHigh(%d, %d) = %d\n\n", from, to, SayFirstHalfHigh(from, to));
//    printf("SaySecondHalfHigh(%d, %d) = %d\n\n", from, to, SaySecondHalfHigh(from, to));

return 0;
}
*/




char *makeAcc2(char *toacc) {  // make a phrase, readable

    int i=0;

    while (i<strlen(toacc)) {
	if (toacc[i] < 28 )	// elimina i caratteri di controllo < 28
	    toacc[i] = ' ';
	i++;
    }
    
return toacc;
}



char *pari(char *toacc) {  // make a phrase, readable

    int i=0, reti=0, pari=0;
    char *ret = (char *) malloc(256);

    while (i++<strlen(toacc)) {
	if (pari--) 
	    ret[reti++] = toacc[i];
	else pari=pari+2;
    }
    ret[reti] = '\0';
    
return ret;
}


char *dispari(char *toacc) {  // make a phrase, readable

    int i=0, reti=0, pari=1;
    char *ret = (char *) malloc(256);

    while (i++<strlen(toacc)) {
	if (pari--) 
	    ret[reti++] = toacc[i];
	else pari=pari+2;
    }
    ret[reti] = '\0';
    
return ret;
}
	


int isHighL(char *line) {	//  passargli solo i dispari

    int i=0;
    
    for(i=0; i<strlen(line); i++) {
	if ( (line[i] & 0x30) == 0x30) return 1;
    }

return 0;
}



char *selectH(char *line) {	// passargli pari e dispari (ritorna pari)

    int i=0, reti=0;
    char *ret = (char *) malloc(256);
    
//    printf("line: %s\n\n", line);
    for(i=1; i<strlen(line); i=i+2) {
	if ( (line[i] & 0x30) == 0x30) ret[reti++] = line[i-1];
    }
//    printf("ret: %s\n\n", ret);

return ret;
}



/*
int makeArgs(char *args, int argn) {
    int ret = 0, i=0;
    
    
    while (args[i] == ' ') i++;

    while((args[i]>='0') && (args[i]<='9')) 
        ret = (ret*10) + (args[i++] - '0');
    if (argn == 1) return ret;
    
    ret = 0;
    while ((args[i] == ' ') || (args[i] == ',')) i++;
    while((args[i]>='0') && (args[i]<='9')) 
	ret = (ret*10) + (args[i++] - '0');

return ret;
}

*/


/*
char *makeAcc(char *toacc) {  // make a phrase, readable

int i=0;

    while (i<strlen(toacc)) {
	if (!(((toacc[i]>='a') && (toacc[i]<='z')) || ((toacc[i]>='A') && (toacc[i]<='Z')) || (toacc[i]=='.') || ((toacc[i]>='0') && (toacc[i]<='9')) ) )
	    toacc[i] = ' ';
	i++;
    }
    
return toacc;
}
	
*/
